package org.stm.wb.emp.controller;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.DateUtils;
import org.stm.wb.emp.entity.WbEmp;
import org.stm.wb.emp.service.IWbEmpService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 外包人员管理
 * @Author: jeecg-boot
 * @Date:   2025-09-09
 * @Version: V1.0
 */
@Api(tags="外包人员管理")
@RestController
@RequestMapping("/wb/wbEmp")
@Slf4j
public class WbEmpController extends JeecgController<WbEmp, IWbEmpService> {
	@Autowired
	private IWbEmpService wbEmpService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbEmp
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "外包人员管理-分页列表查询")
	@ApiOperation(value="外包人员管理-分页列表查询", notes="外包人员管理-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<WbEmp>> queryPageList(WbEmp wbEmp,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbEmp> queryWrapper = QueryGenerator.initQueryWrapper(wbEmp, req.getParameterMap());
		Page<WbEmp> page = new Page<WbEmp>(pageNo, pageSize);
		IPage<WbEmp> pageList = wbEmpService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @RequestMapping(value = "/queryall", method = RequestMethod.GET)
	 public Result<List<WbEmp>> queryall() {
		 Result<List<WbEmp>> result = new Result<>();
		 List<WbEmp> list = wbEmpService.queryall();

		 if(list==null||list.size()<=0) {
			 result.setResult(null);
			 result.setSuccess(true);
		 }else {
			 result.setResult(list);
			 result.setSuccess(true);
		 }
		 return result;
	 }
	
	/**
	 *   添加
	 *
	 * @param wbEmp
	 * @return
	 */
	@AutoLog(value = "外包人员管理-添加")
	@ApiOperation(value="外包人员管理-添加", notes="外包人员管理-添加")
	@RequiresPermissions("wb:wb_emp:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbEmp wbEmp) {
		wbEmpService.save(wbEmp);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbEmp
	 * @return
	 */
	@AutoLog(value = "外包人员管理-编辑")
	@ApiOperation(value="外包人员管理-编辑", notes="外包人员管理-编辑")
	@RequiresPermissions("wb:wb_emp:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbEmp wbEmp) {
		wbEmpService.updateById(wbEmp);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "外包人员管理-通过id删除")
	@ApiOperation(value="外包人员管理-通过id删除", notes="外包人员管理-通过id删除")
	@RequiresPermissions("wb:wb_emp:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbEmpService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "外包人员管理-批量删除")
	@ApiOperation(value="外包人员管理-批量删除", notes="外包人员管理-批量删除")
	@RequiresPermissions("wb:wb_emp:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbEmpService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "外包人员管理-通过id查询")
	@ApiOperation(value="外包人员管理-通过id查询", notes="外包人员管理-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<WbEmp> queryById(@RequestParam(name="id",required=true) String id) {
		WbEmp wbEmp = wbEmpService.getById(id);
		if(wbEmp==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbEmp);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbEmp
    */
    @RequiresPermissions("wb:wb_emp:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbEmp wbEmp) {
        return super.exportXls(request, wbEmp, WbEmp.class, "外包人员管理");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb:wb_emp:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbEmp.class);
    }

	 /**
	  * 对外接口-外包人员入场信息
	  *
	  * @param workNo
	  * @param username
	  * @param dept
	  * @param post
	  * @param orgName
	  * @return
	  */

	 @RequestMapping(value = "/sendWbEmpInfoApi", method = RequestMethod.GET)
	 public Result<String> sendWbEmpInfoApi(@RequestParam(name="workNo",required=true) String workNo,
											@RequestParam(name="username",required=true) String username,
											@RequestParam(name="dept",required=true) String dept,
											@RequestParam(name="post",required=true) String post,
											@RequestParam(name="orgName",required=true) String orgName,
											@RequestParam(name="inDay",required=true) String inDay) {
		 Result<String> result = new Result<>();
		 WbEmp emp=new WbEmp();
		 try {
			 emp.setWorkNo(workNo);
			 emp.setUsername(username);
			 emp.setSysOrgCode(dept);
			 emp.setPost(post);
			 emp.setOrgName(orgName);
			 emp.setCreateTime(new Date());
			// emp.setInTime(new Date());
			 emp.setInDay(inDay);
			 emp.setPostStatus("在岗");

			 wbEmpService.save(emp);
			 result.setResult("发送成功!");
			 result.setSuccess(true);
		 } catch (Exception e) {
			 result.setResult("发送失败!");
			 result.setSuccess(false);
		 }
		 return result;
	 }


	 /**
	  * 对外接口-外包人员离场信息
	  *
	  * @param workNo
	  * @param username
	  * @param outDay
	  * @param remark
	  * @return
	  */

	 @RequestMapping(value = "/sendWbEmpOutInfoApi", method = RequestMethod.GET)
	 public Result<String> sendWbEmpOutInfoApi(@RequestParam(name="workNo",required=true) String workNo,
											@RequestParam(name="username",required=true) String username,
											   @RequestParam(name="outDay",required=true) String outDay,
											   @RequestParam(name="remark",required=true) String remark) {
		 Result<String> result = new Result<>();
		 WbEmp emp=new WbEmp();
		 try {
			 emp.setWorkNo(workNo);
			 emp.setUsername(username);

			 emp.setCreateTime(new Date());
			 emp.setOutDay(outDay);
			 emp.setRemark(remark);
			 emp.setPostStatus("离场");

			 wbEmpService.updateempout(emp);
			 result.setResult("发送成功!");
			 result.setSuccess(true);
		 } catch (Exception e) {
			 result.setResult("发送失败!");
			 result.setSuccess(false);
		 }
		 return result;
	 }



}
